local class = require("middleclass")

local action_stack = class("action_stack")

action_stack.static.NO_ACTION = 0
action_stack.static.UP_ACTION = 1
action_stack.static.DOWN_ACTION = -1
action_stack.static.LEFT_ACTION = -2
action_stack.static.RIGHT_ACTION = 2

function action_stack:initialize()
	self.stack = {}
end

function action_stack:add(value)
	-- Max 4 keys allowed simultaneously
	if #self.stack < 4 then
		table.insert(self.stack, value)
	end
end

function action_stack:remove(value)
	-- Find the index that holds the value
	for i, v in ipairs(self.stack) do
		if v == value then
			table.remove(self.stack, i)
			break
		end
	end
end

function action_stack:get_action()
	local r = self.stack[#self.stack]
	
	if r == nil then
		return action_stack.NO_ACTION
	end
	
	return r
end

return action_stack
