local class = require("middleclass")

local point = class("point")

function point:initialize(x, y)
	self.x = x
	self.y = y
end

function point:copy()
	return point:new(self.x, self.y)
end

function point:distance(p)
	return math.sqrt((p.x - self.x)^2 + (p.y - self.y)^2)
end

function point:set(x, y)
	self.x = x
	self.y = y
end

function point:set_to_point(p)
	self.x = p.x
	self.y = p.y
end

function point:__eq(p) 
	return self.x == p.x and self.y == p.y
end

return point
